//+------------------------------------------------------------------+
//|                                                      MACD+MA.mq4 |
//|                             Copyright  2006, Victor Chebotariov |
//|                                      http://www.chebotariov.com/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Victor Chebotariov"
#property link      "http://www.chebotariov.com/"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  Red
#property indicator_color2  Blue
#property  indicator_width1 1
#property  indicator_width2 1

//
//
//
//
//

extern int period             = 14;
extern int ma_shift           = 0;
extern int ma_method          = 3;//0-3
extern int applied_price_ma   = 0;//0-6
extern int fast_ema_period    = 12;
extern int slow_ema_period    = 26;
extern int applied_price_macd = 0;

//
//
//
//
//

double Buffer1[];
double Buffer2[];
double trend[];

//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
  {
   
   IndicatorBuffers(3);
   SetIndexBuffer(0,Buffer1); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,159);
   SetIndexBuffer(1,Buffer2); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,159);
   SetIndexBuffer(2,trend);
   
   IndicatorShortName("MACD+MA");
return(0);
}
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   int i,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
   
   //
   //
   //
   //
   //
   
   for(i=limit; i >= 0; i--)
   {
     
      double MA_0   = iMA(NULL,0,period,ma_shift,ma_method,applied_price_ma,i);
      double MA_1   = iMA(NULL,0,period,ma_shift,ma_method,applied_price_ma,i+1);
      double MACD_0 = iMACD(NULL,0,fast_ema_period,slow_ema_period,9,applied_price_macd,MODE_MAIN,i);
      double MACD_1 = iMACD(NULL,0,fast_ema_period,slow_ema_period,9,applied_price_macd,MODE_MAIN,i+1);
      
         Buffer2[i] = EMPTY_VALUE;
         Buffer1[i] = EMPTY_VALUE;
         trend[i]   = trend[i+1];
         if(MA_0>MA_1 && MACD_0>MACD_1) trend[i] = 1;
         if(MA_0<MA_1 && MACD_0<MACD_1) trend[i] =-1;
         if(trend[i] == 1)  Buffer2[i]=High[i];
         if(trend[i] ==-1)  Buffer1[i]=Low[i]; 
    
     }
return(0);
}
//+------------------------------------------------------------------+